<%-- $Id:index.jsp 4187 2008-03-20 11:15:25Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
 	import="net.sf.basedb.util.extensions.ExtensionPoint"
	import="net.sf.basedb.util.extensions.Extension"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.ExtensionsFile"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
	final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";

String forward = null;
String redirect = null;
String message = null;
DbControl dc = null;
try
{
	if (cmd == null || "List".equals(cmd))
	{
		forward = "manager.jsp";
	}
	else if ("SaveSettings".equals(cmd))
	{
		dc = sc.newDbControl();
		ExtensionsControl ec = ExtensionsControl.get(dc);
		ec.setAutoInstall(Values.getInt(request.getParameter("autoInstall")));
		ec.saveSettings();
		message = "Settings updated";
	}	
	else if ("EnableExtension".equals(cmd))
	{
		dc = sc.newDbControl();
		String extensionId = request.getParameter("extensionId");
		boolean enable = Values.getBoolean(request.getParameter("enable"));
		ExtensionsControl ec = ExtensionsControl.get(dc);
		ec.enableExtension(extensionId, enable);
		ec.saveSettings();
		redirect = "details.jsp?ID=" + ID + "&extensionId=" + extensionId;
	}
	else if ("EnableExtensionPoint".equals(cmd))
	{
		dc = sc.newDbControl();
		String extensionPointId = request.getParameter("extensionPointId");
		boolean enable = Values.getBoolean(request.getParameter("enable"));
		ExtensionsControl ec = ExtensionsControl.get(dc);
		ec.enableExtensionPoint(extensionPointId, enable);
		ec.saveSettings();
		redirect = "details.jsp?ID=" + ID + "&extensionPointId=" + extensionPointId;
	}
	else if ("EnableFile".equals(cmd))
	{
		dc = sc.newDbControl();
		String filename = request.getParameter("filename");
		boolean enable = Values.getBoolean(request.getParameter("enable"));
		ExtensionsControl ec = ExtensionsControl.get(dc);
		ec.enableAllInFile(filename, enable);
		ec.saveSettings();
		redirect = "details.jsp?ID=" + ID + "&filename=" + HTML.urlEncode(filename);
	}
	else if ("ManualScan".equals(cmd))
	{
		forward = "manual_scan.jsp?ID=" + ID;
	}
	else if ("DoManualScan".equals(cmd))
	{
		dc = sc.newDbControl();
		ExtensionsControl ec = ExtensionsControl.get(dc);
		boolean forceUpdate = Values.getBoolean(request.getParameter("forceUpdate"));
		ec.installAndUpdateExtensions(forceUpdate);
		redirect = "index.jsp?ID=" + ID + "&cmd=ScanResults";
	}
	else if ("ScanResults".equals(cmd))
	{
		forward = "scan_results.jsp?ID=" + ID;
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
finally
{
	if (dc != null) dc.close();
}

if (forward != null)
{
	pageContext.forward(forward);
}
else if (redirect != null)
{
	response.sendRedirect(redirect);
}
else if (message == null)
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&wait=0");
}
else
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&message="+HTML.urlEncode(message));
}
%>

