<%-- $Id: select_installation_type.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2007 Johan Enell, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------


	@author Martin
	@version 2.5
--%>

<%@ page session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"	
	import="net.sf.basedb.core.SessionControl"
	
	import="net.sf.basedb.clients.web.Base"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final Item itemType = Item.PLUGINDEFINITION;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();

String title = "Installation type";
String pluginPath = request.getParameter("plugin_path");

try
{
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head>
		<script language="JavaScript">
		
			var lastSelectedType;
			function typeOnChange()
			{
				var frm = document.forms['installations'];
				var types = frm.installationtypes;
				var type = types[types.selectedIndex].value;		
				
				if (lastSelectedType)
				{
					Main.hide('description.'+lastSelectedType)
				}				
				Main.show('description.'+type);
				if (type == 'autoinstall')
				{
					Main.show('plugindir');
				}
				else
				{
					Main.hide('plugindir');
				}
				lastSelectedType = type;
			}
			function doNext()
			{
				var frm = document.forms['installations'];
				frm.submit();
			}			
			function init()
			{
				typeOnChange();
			}
		</script>
	</base:head>
	<base:body onload="init()">
		<form name="installations" action="index.jsp" method="get" onsubmit="return false;">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="cmd" value="InstallationType">
		<input type="hidden" name="plugin_path" value="<%=pluginPath%>">
	
		<h3 class="docked"><%=title%> <base:help helpid="plugindefinition.installationtype" /></h3>
		<div class="boxed">
			<div class="helpmessage">
				Select how to install the plugin(s).
			</div>
			
			<table class="form" width="100%">
			<tr valign="top">
				<td class="prompt" width="100px">Install</td>
				<td>
					<select name="installationtypes" class="required" onchange="typeOnChange()">
						<option value="autoinstall">Automatically</option>
						<option value="manuellinstall">Manually</option>
					</select>
				</td>
			</tr>
			<tr id="plugindir" valign="top" style="display:none;">
				<td class="prompt">Path</td>
				<td><i><%=pluginPath%></i></td>
			</tr>				
			</table>
			
			<div id="descriptions" class="helpmessage">
				<div id="description.autoinstall" style="display:none;">
					<b>Automatically install non-core plugins</b><br>
					The path above will be scanned for plugins in jar-files.<br>
					Plugins that were found will be available for selection in the next step.
				</div>
				<div id="description.manuellinstall" style="display:none;">
					<b>Manually install plugins</b><br>
					The plugins class name and jar path have to be defined manually.
				</div>
			</div>
		</div>
		</form>
		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="doNext();" title="Next" /></td>
			<td width="50%"><base:button onclick="window.close();" title="Cancel" /></td>
		</tr>
		</table>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
 %>
 